// Code generated by go-swagger; DO NOT EDIT.

package virtual_machines

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// VMDeleteHandlerFunc turns a function with the right signature into a vm delete handler
type VMDeleteHandlerFunc func(VMDeleteParams) middleware.Responder

// Handle executing the request and returning a response
func (fn VMDeleteHandlerFunc) Handle(params VMDeleteParams) middleware.Responder {
	return fn(params)
}

// VMDeleteHandler interface for that can handle valid vm delete params
type VMDeleteHandler interface {
	Handle(VMDeleteParams) middleware.Responder
}

// NewVMDelete creates a new http.Handler for the vm delete operation
func NewVMDelete(ctx *middleware.Context, handler VMDeleteHandler) *VMDelete {
	return &VMDelete{Context: ctx, Handler: handler}
}

/*VMDelete swagger:route DELETE /api/vms/{id} Virtual machines vmDelete

Delete virtual machine

*/
type VMDelete struct {
	Context *middleware.Context
	Handler VMDeleteHandler
}

func (o *VMDelete) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewVMDeleteParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
